"""

  Copyright 2005 Mikko Ohtamaa

  See class comments for more details

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as described
  in licence.txt

"""
# Zope imports
from AccessControl import getSecurityManager, ClassSecurityInfo, Unauthorized

# Plone imports
from Products.Archetypes.public import \
    registerType

# Local imports
from ApplicationCategory import ApplicationCategory
from Permissions import *


class ApplicationSubCategory(ApplicationCategory):
    """ Category containing other applications directly """
            
    meta_type      = 'ApplicationSubCategory'
    archetype_name = 'App. category for apps'
    typeDescription= 'Application category containing other applications'
    content_icon   = 'folder_icon.gif'
    _at_rename_from_title = True
    
    filter_content_types = True
    allowed_content_types = [ "Application" ]


    security = ClassSecurityInfo()    
    security.declareProtected(ADD_ISSUES_PERMISSION, 'invokeFactory')

def modify_fti(fti):
    """ Modifies factory type information for Application type
    
    - Use custom permissions    
    """
    
    #print "modify_fti:" + str(fti)
    
    for action in fti.get("actions", ()):
        if action["id"]=="view":
            action["permissions"] = (VIEW_USABILITY_ITEMS_PERMISSION,)
        elif action["id"]=="edit":
            action["permissions"] = (MANAGE_USABILITY_ITEMS_PERMISSION,)

registerType(ApplicationSubCategory)
    
    
    
    
    