"""
    Automatically generate sample Usability content for site
    
    This file is deprecated and is no longer needed.
    It is kept only as a code example.
    
    Copyright 2005 Mikko Ohtamaa

    Generates folder structure for Linux applications.    
"""

import transaction
from StringIO import StringIO
from types import * # Python run-time type identification
from AccessControl import Permissions, getSecurityManager, ClassSecurityInfo, Unauthorized  
from AccessControl.SecurityManagement import setSecurityManager
from AccessControl.SecurityManagement import newSecurityManager
from Products.Archetypes.public import *
from Products.Archetypes.Marshall import PrimaryFieldMarshaller
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName


from Permissions import \
    VIEW_USABILITY_ITEMS_PERMISSION, \
    EDIT_USABILITY_ITEMS_PERMISSION

from config import PROJECTNAME, ISSUE_LEVELS, ISSUE_STATUSES 

portal_owner = 'portal_owner'

sampleData = (    
    "Linux System",    
    ( "Distributions",
        "Fedora",
        "Mandrake",
        "Suse",
        "Debian",
        "Gentoo",
        "Slackware"
    ),
    ( "KDE Based Applications",
        ("Basic Desktop"
            "Kicker",
            "Control Panel"
        ),
        ("Networking",
            "Kopete",
            "Konqueror"
        ),
        ("Multimedia",
            "KAudioMixer",
        )
    ),
    ( "GTK Based Applications",
    
    ),
    ( "Other X11 Applications",
        
    ),
    ( "Console Applications"
    
    ),
)

def createApp(folder, name):
    """ Create a sample application """
    
    id = name.replace(" ", "_").lower()
    folder.invokeFactory(type_name = 'Application',  id=id, title=name)
    
    # Flush transction buffer
    #transaction.get().commit(subtransaction=True)     
    
    return getattr(folder, id)
    
def createFolder(parent, name):
    """ Creates Application Folder
    
    new child:
    id = name without spaces
    title = name
    
    """
    
    id = name.replace(" ", "_").lower()
    
    parent.invokeFactory(type_name = 'ApplicationCategory', id=id, title=name)
        
    child = getattr(parent, id)    
    child.setTitle(name)    
    return child

def folderMaker(curfolder, data):
    """ Recursively go through sample data and create directory tree """
    for item in data:
        if type(item) == TupleType:
            foldername = item[0]
            folderitems = item[1:]

            newfolder = createFolder(curfolder,foldername)
            folderMaker(newfolder, folderitems)            
        else:
            createApp(curfolder, item)
            
def installContent(portal, out):
    """ Adds sample content to the portal
    
    Parameters
        - portal: Plone object
        - out: StringIO output buffer for the installer
    
    """
        
    # We need to login to have proper permissions to manipulate the portal

    # Usability folder id
    usability_id = "usability"
    
    if out == None:
        # Create dummy buffer
        out = StringIO()

    # Create Usability Issues main folder
    if not hasattr(portal, usability_id):
        portal.invokeFactory(type_name = 'ApplicationCategory', id=usability_id, title="Usability Issues")
    else:
        # Sample content exists... bail out  
        out.write("Usability folder already exists. No sample content created.\n")
        return
                
    appfolder = getattr(portal, usability_id)  
    if appfolder == None:
        out.write("Couldn't create main Usability folder.\n")
        return 
        
          
    workflowTool = portal.portal_workflow
    workflowTool.doActionFor(appfolder, "publish")
    
    folderMaker(appfolder, sampleData)
    
    out.write("Created sample content\n")
            
def uninstallContent(portal):
    pass
    